=== debian/changelog ===
libvpl-tools (1.2.0-1) unstable; urgency=medium

  * Initial version. (Closes: #1082794)

 -- Timo Aaltonen <tjaalton@debian.org>  Thu, 26 Sep 2024 17:47:41 +0300
