## libvpl-tools 1.3.0

=== tools/cli/CMakeLists.txt ===
# ##############################################################################
# Copyright (C) Intel Corporation
#
# SPDX-License-Identifier: MIT
# ##############################################################################

add_subdirectory(system_analyzer)
add_subdirectory(val-surface-sharing)
add_subdirectory(vpl-import-export)
add_subdirectory(vpl-inspect)
