=== .github/workflows/lint/requirements.txt ===
virtualenv==v20.24.5
pre-commit
