=== .github/workflows/summary/requirements.txt ===
defusedxml
xlsxwriter
