=== debian/changelog ===
libvpl-tools (1.3.0-1) unstable; urgency=medium

  * New upstream release.

 -- Timo Aaltonen <tjaalton@debian.org>  Thu, 06 Feb 2025 09:40:50 +0200
