## libvpl-tools 1.4.0~1ppa1

=== debian/changelog ===
libvpl-tools (2:1.4.0~1ppa1-noble1) noble; urgency=medium

  * Bump to 1.4.0

  * d/p: drop patches no longer applicable
    - 0002-Force-rDRM-setmode-highest-resolution-for-above-5k.patch

 -- Mustaffa, Mustamin B <mustamin.b.mustaffa@intel.com>  Fri, 22 Aug 2025 17:18:24 +0800

libvpl-tools (2:1.3.0~1ppa1-noble2) noble; urgency=medium

  * debian/patches: Remove Y210 YUV writer shift
    - 0003-Remove-Y210-YUV-writer-shift.patch

 -- Cheah, Vincent Beng Keat <vincent.beng.keat.cheah@intel.com>  Thu, 26 Jun 2025 08:10:35 +0800

libvpl-tools (2:1.3.0~1ppa1-noble1) noble; urgency=medium

  * Bump to 1.3.0 version
  * d/p: drop patches already merged.
    - 0001-Enable-AV1-encode-Screen-Content-Coding-tools.patch
    - 0002-Implement-GTK-using-OpenGL-in-SD-and-SMT.patch
  * d/p: rebased patches
    - 0001-Remove-redundant-fd-close.patch
    - 0002-Force-rDRM-setmode-highest-resolution-for-above-5k.patch

 -- Lim, Siew Hoon <siew.hoon.lim@intel.com>  Thu, 27 Mar 2025 18:45:14 +0800

libvpl-tools (2:1.2.0~1ppa1-noble3) noble; urgency=medium

  * debian/patches: Fix 8K rDRM render
    - 0004-Force-rDRM-setmode-highest-resolution-for-above-5k.patch

 -- Cheah, Vincent Beng Keat <vincent.beng.keat.cheah@intel.com>  Fri, 19 Jul 2024 14:37:57 +0800

libvpl-tools (2:1.2.0~1ppa1-noble2) noble; urgency=medium

  * debian/patches: Fix 8K X11 rendering
    - 0003-Remove-redundant-fd-close.patch

 -- Hoe, Sheng Yang <sheng.yang.hoe@intel.com>  Wed, 06 Nov 2024 13:48:05 +0800

libvpl-tools (2:1.2.0~1ppa1-noble1) noble; urgency=medium

  * Bump to 1.2.0 version

  * d/patches: drop list of patches already merged.
    - 0001-Correct-va-attrib-for-vaapiallocator.patch
    - 0002-Enable-YUV400-JPEG-Enc-for-vaapi.patch
    - 0003-Enable-YUV400-JPEG-Enc-for-linux-vaapi-only.patch
    - 0004-Fix-rDRM-DMA-methods.patch
    - 0005-Force-allocator-to-use-DRM_PRIME-for-rDRM.patch
    - 0006-Enable-VVC-in-sample_decode.patch
    - 0007-Fix-X11-rendering-for-xe.patch
    - 0008-Fix-code-formatting.patch

  * d/patches: rebased the patches
    - 0001-Enable-AV1-encode-Screen-Content-Coding-tools.patch
    - 0002-Implement-GTK-using-OpenGL-in-SD-and-SMT.patch

 -- Lim, Siew Hoon <siew.hoon.lim@intel.com>  Wed, 30 Oct 2024 14:07:46 +0800

libvpl-tools (2:1.0.0~1ppa1-noble5) noble; urgency=medium

  * debian/patches: Implement GTK using OpenGL in SD and SMT
    - 0001-Implement-GTK-using-OpenGL-in-SD-and-SMT.patch 

 -- Lui, Jonathan Ming Jun <jonathan.ming.jun.lui@intel.com>  Thu, 17 Oct 2024 04:05:57 +0000

libvpl-tools (2:1.0.0~1ppa1-noble4) noble; urgency=medium

  * debian/patches: Enable AV1 encode Screen Content Coding tools
    - 0009-Enable-AV1-encode-Screen-Content-Coding-tools.patch

 -- Hoe, Sheng Yang <sheng.yang.hoe@intel.com>  Wed, 18 Sep 2024 11:02:54 +0800

libvpl-tools (2:1.0.0~1ppa1-noble3) noble; urgency=medium

  * Add d/libvpl-tools.install file.

 -- Lim, Siew Hoon <siew.hoon.lim@intel.com>  Tue, 10 Sep 2024 08:28:30 +0800

libvpl-tools (2:1.0.0~1ppa1-noble2) noble; urgency=medium

  *  d/patches: a list of code fixed on sample app not yet merged.
     - 0001-Correct-va-attrib-for-vaapiallocator.patch
     - 0002-Enable-YUV400-JPEG-Enc-for-vaapi.patch
     - 0003-Enable-YUV400-JPEG-Enc-for-linux-vaapi-only.patch
     - 0004-Fix-rDRM-DMA-methods.patch
     - 0005-Force-allocator-to-use-DRM_PRIME-for-rDRM.patch
     - 0006-Enable-VVC-in-sample_decode.patch
     - 0007-Fix-X11-rendering-for-xe.patch
     - 0008-Fix-code-formatting.patch

 -- Lim, Siew Hoon <siew.hoon.lim@intel.com>  Tue, 10 Sep 2024 08:11:03 +0800

libvpl-tools (2:1.0.0~1ppa1-noble1) noble; urgency=medium

  * Initial Release.

 -- LEE CHEE YANG <chee.yang.lee@intel.com>  Thu, 11 Jul 2024 12:58:47 +0800
