=== debian/control ===
Source: libvpl-tools
Section: libs
Priority: optional
Maintainer: Lee Chee Yang <chee.yang.lee@intel.com>
Build-Depends: debhelper-compat (= 13),
 cmake,
 libdrm-dev,
 libva-dev,
 libwayland-dev,
 libx11-dev,
 libx11-xcb-dev,
 libxcb1-dev,
 libxcb-dri3-dev,
 libxcb-present-dev,
 pkg-config,
 wayland-protocols,
 libgtkmm-4.0-dev,
 libvpl-dev (>= 2.11.0)
Standards-Version: 4.6.0
Homepage: 

Package: libvpl-tools
Architecture: amd64
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: oneAPI Video Processing Library -- command line tools
 The oneAPI Video Processing Library (oneVPL) provides a single video processing
 API for encode, decode, and video processing that works across a wide range of
 accelerators.
 .
 This repository contains the following components of oneVPL:
 .
  - Copies of the oneVPL Specification API header files
  - oneVPL dispatcher
  - Examples demonstrating API usage
  - oneVPL command line tools
 .
 This project is part of the larger oneAPI project.
 .
 This package includes the command line tools.
